import pygame,sys
from pygame.locals import *

pygame.init()
pygame.font.init()
mainclock= pygame.time.Clock()
img_mur = pygame.image.load("mur.png")
img_sortie = pygame.image.load("sortie.png")
img_joueur = pygame.image.load("joueur.png")
img_solution = pygame.image.load("chemin.png")
img_sol = pygame.image.load('sol.jpg')
xpix=img_mur.get_width()
ypix=img_mur.get_height()
gauche=False
droite=False
haut=False
bas=False

# m : mur
# j : position du joueur
# s : positiuon de la sortie

Carte=[ "mmmmmmmm",
        "mj     m",
        "mm m   m",
        "m  mm  m",
        "s      m",
        "m  mmm m",
        "m      m",
        "mmmmmmmm"]

larg_laby=len(Carte[0])
Carte=[[caractere for caractere in ligne] for ligne in Carte]
x_carte=len(Carte[0])
y_carte=len(Carte)
fenetre_jeu=pygame.display.set_mode((len(Carte[0])*xpix,len(Carte)*ypix,),0,32)     	# Taille fenêtre du jeu
pygame.display.set_caption('Labyrinthe')          	# titre de la fenêtre


#-----------------collez votre classe GrapheNO ici ------------------------------------



#-----------------Fin de la classe GrapheNO


#------------- Ne pas mofifier les fonctions suivantes -----------------------

class File:
    """objet de classe file"""
    def __init__(self):
        """self -> void
        créer une file vide"""
        self.contenu=[]

    def est_vide(self):
        """self->bool
        Retourne vrai si la file est vide sinon faux"""

        return len(self.contenu)==0


    def enfiler(self,elt):
        """self, int -> None
        enfile un entier dans la file"""
        self.contenu.append(elt)

    def defiler(self):
        """self, int -> int
        précondition : la file ne doit pas être vide
        défile puis retourne la tête de la file"""
        if not self.est_vide():
            return self.contenu.pop(0)
        raise IndexError('la file est vide')


def dessine_carte():
    """dessine la carte en utilisant pygame"""
    global p_depart

    fenetre_jeu.blit(img_sol,(0,0))
    x=0
    y=0
    for ligne in Carte:
        for col in ligne:
            if col=='m':
                fenetre_jeu.blit(img_mur,(x,y))
            if col=='s':
                fenetre_jeu.blit(img_sortie,(x,y))
            if col=='j':
                fenetre_jeu.blit(img_joueur,(x,y))
            x+=xpix
        x=0
        y+=ypix

def dessine_chemin(chem):
    for case in chem:
        case=sommets[case]
        fenetre_jeu.blit(img_solution,(case%x_carte*ypix,case//(x_carte)*ypix))


def deplace_joueur():
    """Déplace le joueur sur les cases libres ou la sotie"""
    pos_vides=recherche(' ')
    pos_vides.append(recherche('s')[0])
    if droite:
        if (pos_joueur[0][0]+1,pos_joueur[0][1]) in pos_vides:
            Carte[pos_joueur[0][1]][pos_joueur[0][0]]=" "
            pos_joueur[0]=pos_joueur[0][0]+1,pos_joueur[0][1]
            Carte[pos_joueur[0][1]][pos_joueur[0][0]]="j"

    if gauche:
        if (pos_joueur[0][0]-1,pos_joueur[0][1]) in pos_vides:
            Carte[pos_joueur[0][1]][pos_joueur[0][0]]=" "
            pos_joueur[0]=pos_joueur[0][0]-1,pos_joueur[0][1]
            Carte[pos_joueur[0][1]][pos_joueur[0][0]]="j"

    if haut:
        if (pos_joueur[0][0],pos_joueur[0][1]-1) in pos_vides:
            Carte[pos_joueur[0][1]][pos_joueur[0][0]]=" "
            pos_joueur[0]=pos_joueur[0][0],pos_joueur[0][1]-1
            Carte[pos_joueur[0][1]][pos_joueur[0][0]]="j"

    if bas:
        if (pos_joueur[0][0],pos_joueur[0][1]+1) in pos_vides:
            Carte[pos_joueur[0][1]][pos_joueur[0][0]]=" "
            pos_joueur[0]=pos_joueur[0][0],pos_joueur[0][1]+1
            Carte[pos_joueur[0][1]][pos_joueur[0][0]]="j"


def recherche(objet):
    """ str -> 2-uplets
    la chaine sera j, s ou espace
    retourne la liste des coordonnées des cases recherchées"""
    liste=[]
    x=0
    y=0
    for ligne in Carte:
        for col in ligne:
            if col==objet:
                liste.append((x,y))
            x+=1
        x=0
        y+=1
    return liste

def liste_sommets(carte):
    """list (str) -> list(int)
    retoune la liste des numéros des sommets de la carte"""
    sommets=[]

    coordonnees=recherche('j')
    coordonnees+=recherche(' ')
    coordonnees+=recherche('s')
    for coordonnee in coordonnees:
        s=coordonnee[0]+coordonnee[1]*larg_laby
        sommets.append(s)
    return sommets


def affiche_matrice(sommets,matrice):
    """list[int],lsit[list[int]] -> void
    affiche la matrice la matrice avec les sommets"""
    print('som.| ',end='')
    for s in sommets:
        print(str(s)+"|", end='')
    print('\n',end=' ')
    for i in range (len(sommets)):
        print(sommets[i],end='  | ')
        for m in matrice[i]:
               print(str(m)+"|",end=' ')
        print('')

def sommet(p):
    pos=recherche(p)[0]
    return pos[1]*larg_laby+pos[0]

def detection_touche():
    global gauche, droite, haut, bas

    for event in pygame.event.get():			# Traiter les évènements du clavier
        if event.type== KEYDOWN:
            if event.key==K_ESCAPE:
                pygame.quit()
                sys.exit()
                break

            if event.key==K_RIGHT:
                droite = True
            if event.key==K_LEFT:
                gauche = True
            if event.key==K_UP:
                haut = True
            if event.key==K_DOWN:
                bas = True


        if event.type== KEYUP:
            if event.key==K_RIGHT:
                droite = False
            if event.key==K_LEFT:
                gauche = False
            if event.key==K_UP:
                haut = False
            if event.key==K_DOWN:
                bas = False



#-------------- FONCTIONS A CREER ------------------

def creer_graphe(sommets):




def parcours_largeur(graphe,depart):




def chemin(graphe,parcours,sortie,pos):




#------------------ Fin des fonctions ---------------------

sommets=liste_sommets(Carte)
sommets.sort() # il n'est pas obligatoire d'ordonner les sommets, pour vérification uniquement
pos_perso=sommet('j')
sortie=sommet('s')

matrice,graphe=creer_graphe(sommets)
affiche_matrice(sommets,matrice)

parcours=parcours_largeur(graphe,sommets.index(pos_perso))
ch=chemin(graphe,parcours,sommets.index(sortie),sommets.index(pos_perso))

pos_joueur=recherche('j')
pos_sortie=recherche('s')

while pos_sortie!=pos_joueur:


    detection_touche()
    if gauche or droite or haut or bas:
        deplace_joueur()
        pos=sommet('j')
        parcours=parcours_largeur(graphe,sommets.index(pos))
        ch=chemin(graphe,parcours,sommets.index(sortie),sommets.index(pos))
    dessine_carte()
    dessine_chemin(ch[0:-1])

    pygame.display.update()
    mainclock.tick(10)

dessine_carte()
pygame.display.update()
mainclock.tick(1)
pygame.quit()
sys.exit()